
# Description: Holds the settings and configurations for the project.

"""
Django settings for DjangoAPI project.

Generated by 'django-admin startproject' using Django 4.0.3.

For more information on this file, see
https://docs.djangoproject.com/en/4.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.0/ref/settings/
"""

import mysql.connector as mysql
from pathlib import Path
import os
from os.path import abspath, basename, dirname  # , join, normpath
from django.conf import settings
from dotenv import load_dotenv

# Loading environment variables from '.env
load_dotenv(override=True)

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

# Absolute filesystem path to this Django project directory.
DJANGO_ROOT = dirname(dirname(abspath(__file__)))

# Site name.
SITE_NAME = basename(DJANGO_ROOT)

# Absolute filesystem path to the top-level project folder.
SITE_ROOT = dirname(DJANGO_ROOT)

# URL roots - change these to change where front-/backend is hosted!
# Don't forget to adjust protocol depending on whether you've got TLS working
URL_ROOT_BACKEND = os.getenv('URL_ROOT_BACKEND')
URL_ROOT_FRONTEND = os.getenv('URL_ROOT_FRONTEND')
# URL_ROOT_BACKEND = 'https://backend.jarves.nfdi4ing.de'
# URL_ROOT_FRONTEND = 'https://jarves.nfdi4ing.de'
URL_ROOT_DATABASE = 'srv-db.zlw-ima.rwth-aachen.de'


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.0/howto/deployment/checklist/

#sk = os.getenv('SECRET_KEY')
# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.getenv('DJANGO_SECRET_KEY')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True
if DEBUG:
    print("WARNING: RUNNING IN DEBUG MODE\n"*3)

#ALLOWED_HOSTS: list = ["https://137.226.188.67", "jarves-backend.rancher-ima.zlw-ima.rwth-aachen.de", "localhost", "127.0.0.1", "https://backend.jarves.nfdi4ing.de/"]
ALLOWED_HOSTS = ['*']


AUTHENTICATION_BACKENDS = [
    # Needed to login by username in Django admin, regardless of `allauth`
    'django.contrib.auth.backends.ModelBackend',
    # `allauth` specific authentication methods, such as login by e-mail
    'allauth.account.auth_backends.AuthenticationBackend',
]

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'corsheaders',  # CORS
    'rest_framework',  # Django REST framework
    'DatabaseRouters.apps.DatabaseRoutersConfig',  # Routers for the Databases
    'ProjectAPP.apps.ProjectAPPConfig',  # App for Projects and related models
    'Policies.apps.PoliciesConfig', # App for Policies
    'Feedback.apps.FeedbackConfig',  # App for Projects and related models   
    'django_extensions', # Automatic UML creation
    'django.contrib.sites',
    'allauth',
    'allauth.account',
    'allauth.socialaccount',
    'allauth.socialaccount.providers.orcid',
    'apiservices.apps.ApiservicesConfig',
    'rest_framework_swagger',
    'drf_yasg',
    'TrainingMaterials.apps.TrainingmaterialsConfig', # RDM Training materials
    #'NameOfTheApp.apps.NameOfTheAppConfig', # NameOfTheApp application
    'django_minio_backend'
]

MIDDLEWARE = [
    'corsheaders.middleware.CorsMiddleware',  # CORS
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'django.middleware.common.CommonMiddleware',  # CORS
    'clacks.middleware.ClacksMiddleware',  # Clacks
    'whitenoise.middleware.WhiteNoiseMiddleware', # Serve static
]

CSRF_TRUSTED_ORIGINS = [  # TODO: some of these are not needed
    "https://backend.jarves.nfdi4ing.de",
    "https://jarves.nfdi4ing.de",
    "http://backend.jarves.nfdi4ing.de",
    "http://jarves.nfdi4ing.de",
    "https://srv-www02.zlw-ima.rwth-aachen.de",
    "http://127.0.0.1",
    "http://127.0.0.1:4200",
    "http://127.0.0.1:8000",
    "http://localhost:4200",
    "http://localhost:8000",
    "http://137.226.188.67",
    "https://137.226.188.67",
]

STATIC_ROOT = os.path.join(BASE_DIR, 'staticfiles')
STATIC_URL = '/static/'
STATICFILES_DIRS = (
  os.path.join(STATIC_ROOT, 'static/'),
)

#STATICFILES_STORAGE = 'whitenoise.storage.CompressedManifestStaticFilesStorage'
STATICFILES_STORAGE = 'django.contrib.staticfiles.storage.StaticFilesStorage'
# CORS Settings

CORS_ORIGIN_ALLOW_ALL = True
CORS_ORIGIN_WHITELIST = (  # TODO: some of these are not needed
    # Allow only origins listed below
    'http://localhost',
    'http://localhost:80',
    'http://localhost:4200',
    'http://localhost:8000',

    'http://127.0.0.1',
    'http://127.0.0.1:80',
    'http://127.0.0.1:4200',
    'http://127.0.0.1:8000',

    'http://jarves-frontend.rancher-ima.zlw-ima.rwth-aachen.de',
    'https://jarves-frontend.rancher-ima.zlw-ima.rwth-aachen.de',
    'https://jarves.nfdi4ing.de',

    'http://137.226.188.67',
    'https://137.226.188.67',
)

CORS_ALLOW_CREDENTIALS = True

SOCIAL_AUTH_LOGIN_REDIRECT_URL = f'{URL_ROOT_FRONTEND}/projects'

USE_X_FORWARDED_HOST = True
# DRF Settings
# REST_FRAMEWORK = {
#    'DEFAULT_PAGINATION_CLASS': 'rest_framework.pagination.PageNumberPagination',
#    'PAGE_SIZE': 10
# }
SITE_ID = 1

ACCOUNT_LOGOUT_ON_GET = True
ACCOUNT_LOGOUT_REDIRECT_URL = f"{URL_ROOT_FRONTEND}/landing"

SOCIALACCOUNT_LOGIN_ON_GET=True

ROOT_URLCONF = 'DjangoAPI.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'django.template.context_processors.request',
            ],
        },
    },
]



WSGI_APPLICATION = 'DjangoAPI.wsgi.application'

SWAGGER_SETTINGS = {
   'USE_SESSION_AUTH': False
}

db = {
    'ENGINE': 'django.db.backends.mysql',
    'NAME': os.getenv('MYSQL_DBNAME'),
    'USER': os.getenv('MYSQL_USERNAME'),
    'PASSWORD': os.getenv('MYSQL_PASSWORD'),
    'HOST': os.getenv('MYSQL_HOST'),
    'PORT': os.getenv('MYSQL_PORT'),
    'OPTIONS': {
            'charset': 'utf8mb4',
        }
}

print(db)
# Database
# https://docs.djangoproject.com/en/4.0/ref/settings/#databases
# For multiple databases see: https://docs.djangoproject.com/en/4.0/topics/db/multi-db/
DATABASES = {
    'default': db,
    'Jarves_db': db,
}

# Database routers for automatic routing of databases
# Databases are queried in this order:
DATABASE_ROUTERS = [
    'DatabaseRouters.JarvesRouter.JarvesRouter',
]

managed=True
# If no match is found, Django resides to the 'default' Database


# Password validation
# https://docs.djangoproject.com/en/4.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

# Automatic UML creation
GRAPH_MODELS = { 
  'all_applications': True,
  'group_models': True,
}

# Internationalization
# https://docs.djangoproject.com/en/4.0/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'CET'

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.0/howto/static-files/

STATIC_URL = 'static/'

# Default primary key field type
# https://docs.djangoproject.com/en/4.0/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'


LOGGING = {

    # Version
    'version': 1,  # the dictConfig format version
    'disable_existing_loggers': False,  # retain the default loggers

    # Here all formaters (What shall the log display?) are defined:
    'formatters': {
        'standard': {
            'format': '{asctime} {levelname} {module} {message}',  # for mor formats see: https://docs.python.org/3/library/logging.html#logrecord-attributes
            'style': '{',
        },
        'simple': {
            'format': '{levelname} {message}',
            'style': '{',
        },
    },


    # Here filters go here if needed.


    # Here all handlers (How shall the log display? --> particular logging behavior, such as writing a message to the screen, to a file, ...) are defined:
    # Uses formatter.
    'handlers': {
        'console': {
            'level': 'DEBUG',
            'class': 'logging.StreamHandler',
            'formatter': 'standard'
        },
        'general_file': {
            'level': 'DEBUG',
            'class': 'logging.FileHandler',
            'filename': os.path.join(DJANGO_ROOT, "Logs/debug.log"),
            'formatter': 'standard'
        },
        'database_file': {
            'level': 'DEBUG',
            'class': 'logging.FileHandler',
            'filename': os.path.join(DJANGO_ROOT, "Logs/database.log"),
            'formatter': 'standard'
        },
    },

    # Here all loggers (Entry point to logging system: named bucket to which messages can be written for processing) are defined:
    # Uses handlers (multiple can be used)
    'loggers': {

        # The following examples will capture logs only from loggers with matching names
        'console_logger': {
            'handlers': ['console'],
            'level': 'INFO',
            'propagate': True,  # Defines if higher in logger hirachy are allowed here as well
        },
        'file_logger': {
            'handlers': ['general_file'],
            'level': 'INFO',
        },
        'ProjectAPP.views': {
            'handlers': ['console', 'general_file'],
            'level': 'INFO',
            'propagate': True,
        },
        'Database_logger': {
            'handlers': ['console', 'database_file'],
            'level': 'DEBUG',
            'propagate': True,
        },

        # The following will handle information from ALL loggers
        # '': {
        #    'handlers': ['general_file'],
        #    'level': 'DEBUG',
        # }
    }
}

REST_FRAMEWORK = {
    'DEFAULT_SCHEMA_CLASS': 'rest_framework.schemas.coreapi.AutoSchema'
}


MINIO_ENDPOINT = os.environ.get("AWS_S3_ENDPOINT_URL")
MINIO_ACCESS_KEY = os.environ.get("AWS_ACCESS_KEY_ID")
MINIO_SECRET_KEY = os.environ.get("AWS_SECRET_ACCESS_KEY")
MINIO_USE_HTTPS = False
MINIO_PRIVATE_BUCKETS = [
    'django-backend-dev-private',
]
# MINIO_CONSISTENCY_CHECK_ON_START = True



# This will check if the environment variable DJANGO_ENVIRONMENT is set to 'production'.
# If not so, the settings_dev.py file will be used to overwrite the settings.
# if os.getenv("DJANGO_ENVIRONMENT")  != "production":
#     from .settings_dev import *